variables:
  GIT_SUBMODULE_STRATEGY: recursive

stages:
  - test
  - generate-html
  - generate-pdf
  - test-urls

test-urls:
  image: debian:buster-slim
  stage: test-urls
  tags:
    - lightweight
  before_script:
  - apt update && apt install -y --no-install-recommends
      python3
      python3-markdown
      python3-requests
  script:
  - scripts/test_urls.py content/
  # We are running this for all commits for all URLs on the website, so it
  # wouldn't be fair to block a merge due to an unrelated URL suddenly failing.
  # Treat this as a warning that the site has degraded.
  allow_failure: true
  needs: []

test-images:
  image: debian:buster-slim
  stage: test
  tags:
    - lightweight
  before_script:
  - apt update && apt install -y --no-install-recommends
      python3
      python3-markdown
  script:
  - scripts/check_images.py .

test-html:
  image:
    name: klakegg/hugo:latest
    entrypoint: [""]
  stage: generate-html
  tags:
    - lightweight
  script:
  - DEFAULT_BASEURL=${CI_PAGES_URL##http:} # don't force stuff on plain HTTP when publishing on HTTPS
  - BASEURL=${BASEURL:-$DEFAULT_BASEURL} # set BASEURL in the CI variables to override it
  - echo "Using base URL '$BASEURL'"
  - hugo -b "${BASEURL}"
  artifacts:
    paths:
    - public

.gen-pdf:
  image: docker-registry.apertis.org/apertis/apertis-v2020-documentation-builder
  stage: generate-pdf
  tags:
    - lightweight
  script:
  - echo "Building PDFs on $(nproc) cores"
  - find public -name "*.pdf-in" -print0 | xargs -0 -r -n1 -P "$(nproc)" scripts/create-pdf
  needs:
  - job: test-html
  artifacts:
    paths:
    - public

test-pdf:
  extends: .gen-pdf
  except:
  - master

pages:
  extends: .gen-pdf
  only:
  - master
